Codeforces - 1321B - Journey Planning(思维)

题目链接

题目大意:让你找出一列数,他们中相邻的两个数的下标之差等于数值之差。求这列数的最大值

??思路很简单,因为所得数列满足相邻的两个数的下标之差等于数值之差。所以只要让每个输入的数减去对应的下标所得到的下标指向的数加上这个数即可,如果两个数的下标之差等于数值之差,那么

它们各自的数减去下标所得到的下标指向的必定是同一个位置。换句话说,这个位置的数等于所有两个数的下标之差等于数值之差的数的和。(这样的位置可以有多个)

//https://www.cnblogs.com/shuitiangong/
#include<set>
#include<map>
#include<list>
#include<stack>
#include<queue>
#include<cmath>
#include<cstdio>
#include<cctype>
#include<string>
#include<vector>
#include<climits>
#include<cstring>
#include<cstdlib>
#include<iostream>
#include<algorithm>
#define endl ‘\n‘
#define rtl rt<<1
#define rtr rt<<1|1
#define lson rt<<1, l, mid
#define rson rt<<1|1, mid+1, r
#define zero(a) memset(a, 0, sizeof(a))
#define INF(a) memset(a, 0x3f, sizeof(a))
#define IOS ios::sync_with_stdio(false)
#define _test printf("==================================================\n")
using namespace std;
typedef long long ll;
typedef pair<int, int> P;
typedef pair<ll, ll> P2;
const double pi = acos(-1.0);
const double eps = 1e-7;
const ll MOD =  998244353;
const int INF = 0x3f3f3f3f;
const int maxn = 1e6+10;
ll arr[maxn];
int main(void) {
    IOS; int n;
    const int top = 2e5+10;
    while(cin>>n) {
        ll ans = 0, num;
        for (int i = 1; i<=n; ++i) {
            cin >> num;
            arr[top+num-i] += num;
            ans = max(ans, arr[top+num-i]);
        }
        cout << ans << endl;
    }
    return 0;
}

原文地址:https://www.cnblogs.com/shuitiangong/p/12573257.html

时间: 2024-10-07 05:54:14

Codeforces - 1321B - Journey Planning(思维)的相关文章

CodeForces 1102C-简单的思维题

题目链接:http://codeforces.com/problemset/problem/1102/C C. Doors Breaking and Repairing time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output You are policeman and you are playing a game with Slavik

B. Journey Planning

Codeforces Round #625 (Div. 2, based on Technocup 2020 Final Round) time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output Tanya wants to go on a journey across the cities of Berland. There are n

CodeForces 789D 欧拉路径计数,思维

CodeForces 789D 题意:n个点m条边的无向图,求经过其中m-2条边两次,剩下2条边一次的方案数有几种,如果剩下两条边的集合一样算同一种. tags: 选出两条边,其它m-2条边假想复制成两条,这样就是要求欧拉路径是否存在,即奇点个数是否为0或2. 所以该怎么选这两条边呢? 先把边分为自环边和普通边. 1.选取两条不相邻普通边,图中存在4个奇点,不满足欧拉路径条件: 2.选取两条相邻普通边,图中存在2个奇点,满足欧拉路径条件: 3.选取一条普通边一条自环,图中存在2个奇点,满足欧拉路

CodeForces 789E bfs建模,思维

CodeForces 789E 题意:有k种可乐,每种的测试为ai/1000. 要你合成一种浓度为n/1000的可乐,问最小要杯可乐,每种可乐可重复取. tags:  要注意到浓度绝不会超过1000/1000. 假设选取m杯可乐,则 (a1+a2+......+am) / m = n,变换一下为(a1-n)+(a2-n)+......+(am-n) = 0.即要选 m杯可乐,其浓度减 n之和为0.而浓度不超过1000,故(a1-n)+(a2-n)+....+(as-n)的和肯定在 -1000~1

CodeForces 788B--Weird journey

Time Limit:2000MS     Memory Limit:262144KB     64bit IO Format:%I64d & %I64u Description Little boy Igor wants to become a traveller. At first, he decided to visit all the cities of his motherland - Uzhlyandia. It is widely known that Uzhlyandia has

2017-03-16 Codeforces 453A 概率期望,思维 UOJ 228(待补)

Codeforces 453A   A. Little Pony and Expected Maximum 题意:一个m面质地均匀的骰子,每面出现的概率都是独立的1/m, 你需要投掷n次,其结果是这n次出现的最大点数.问投掷n次骰子的结果的期望值是多少,要求相对误差或绝对误差不超过1e-4. tags:枚举骰子出现最大值i,计算出最大值为i时的概率,就得到了答案. 最大值为i的概率=(i/m)^n-((i-1)/m)^n. #include<bits/stdc++.h> using names

Codeforces Round #399 B 思维 C 模拟 D 概率dp E SG博弈

Divide by Zero 2017 and Codeforces Round #399 (Div. 1 + Div. 2, combined)B. Code For 1 题意:数n,不断拆分为 n/2, n&1, n/2,直到都为0或1.求区间[l, r]有多少个1. tags:画一画很容易看出来,类似dfs中序遍历. //#399 B #include<bits/stdc++.h> using namespace std; #pragma comment(linker, &quo

Codeforces 864 C Bus 思维

题目链接: http://codeforces.com/problemset/problem/864/C 题目描述: 输入a, b, f, k , 一段长度为a的路来回走, 中间f的地方有一个加油站, 油罐的容量为b, 问想要走b次这条路至少需要加多少次油 解题思路: 由于K <= 1e4, 所以将每次需要走路的连续序列构造出来再去遍历一遍这个序列看啥时候需要加油就可以了 代码: #include <iostream> #include <cstdio> #include &

codeforces 497B Tennis Game 思维+二分~

链接:http://codeforces.com/problemset/problem/497/B 这种题考察的是基本功..像我这种基本功为0的喳喳只能卡在这里了... 思路:n范围为10^5, 必须找出nlogn的算法才行.枚举t,然后用二分找出解..巧妙~~ 好题赞一个,虽然不会做~~~ 代码: /* *********************************************** Author :ltwy Created Time :2014年12月18日 星期四 16时28